Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 85446 - Apache seg faults due to mod_ssl
Summary: Apache seg faults due to mod_ssl
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Red Hat Linux
Classification: Retired
Component: mod_ssl
Version: 9
Hardware: i386
OS: Linux
medium
high
Target Milestone: ---
Assignee: Nalin Dahyabhai
QA Contact:
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2003-03-02 22:45 UTC by Andrew Parker
Modified: 2007-04-18 16:51 UTC (History)
0 users

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2003-09-01 10:51:22 UTC


Attachments (Terms of Use)

Description Andrew Parker 2003-03-02 22:45:24 UTC
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.2.1) Gecko/20030206

Description of problem:
From a full (kickstart) install of 8.0.94, Apache seg faults on startup.

Version-Release number of selected component (if applicable):
mod_ssl-2.0.40-20

How reproducible:
Always

Steps to Reproduce:
1.  Install full 8.0.94
2.  service httpd start
3.  service httpd status
    

Actual Results:  root@armari root]# service httpd start
Starting httpd:                                            [  OK  ]
[root@armari root]# service httpd status
httpd dead but subsys locked


Expected Results:  httpd (pid xxx, etc etc etc)

Additional info:

Seg fault found this way:

root@armari root]# gdb /usr/sbin/httpd
GNU gdb Red Hat Linux (5.3post-0.20021129.12rh)
Copyright 2002 Free Software Foundation, Inc.
GDB is free software, covered by the GNU General Public License, and you are
welcome to change it and/or distribute copies of it under certain conditions.
Type "show copying" to see the conditions.
There is absolutely no warranty for GDB.  Type "show warranty" for details.
This GDB was configured as "i386-redhat-linux-gnu"...
(no debugging symbols found)...
(gdb) run -X
Starting program: /usr/sbin/httpd -X
(no debugging symbols found)...(no debugging symbols found)...
(no debugging symbols found)...(no debugging symbols found)...
(no debugging symbols found)...(no debugging symbols found)...
(no debugging symbols found)...(no debugging symbols found)...
(no debugging symbols found)...(no debugging symbols found)...[New Thread
1077404864 (LWP 3796)]

Program received signal SIGSEGV, Segmentation fault.
[Switching to Thread 1077404864 (LWP 3796)]
0x40ae61b0 in ssl_scache_shmcb_status () from /etc/httpd/modules/mod_ssl.so
(gdb) bt
#0  0x40ae61b0 in ssl_scache_shmcb_status () from /etc/httpd/modules/mod_ssl.so
#1  0x400e3cf1 in RAND_SSLeay () from /lib/libcrypto.so.4
#2  0x400e4962 in RAND_bytes () from /lib/libcrypto.so.4
#3  0x40f696c7 in sc_random () from /usr/lib/libnetsnmp.so.5
#4  0x40f803d0 in init_usm_post_config () from /usr/lib/libnetsnmp.so.5
#5  0x40f6aa37 in snmp_call_callbacks () from /usr/lib/libnetsnmp.so.5
#6  0x40f61e97 in read_premib_configs () from /usr/lib/libnetsnmp.so.5
#7  0x40f415f4 in init_snmp () from /usr/lib/libnetsnmp.so.5
#8  0x40bad872 in zm_startup_snmp () from /usr/lib/php4/snmp.so
#9  0x40614193 in php_dl () from /etc/httpd/modules/libphp4.so
#10 0x4059c39e in display_ini_entries () from /etc/httpd/modules/libphp4.so
#11 0x40585158 in zend_llist_apply () from /etc/httpd/modules/libphp4.so
#12 0x4059ca97 in php_ini_delayed_modules_startup ()
   from /etc/httpd/modules/libphp4.so
#13 0x40599921 in php_module_startup () from /etc/httpd/modules/libphp4.so
#14 0x40596ef7 in zend_qsort () from /etc/httpd/modules/libphp4.so
#15 0x0806596a in ap_run_post_config ()
#16 0x0806ae38 in main ()
#17 0x420154a0 in __libc_start_main () from /lib/tls/libc.so.6
(gdb)

****************************************************
Also found this in /etc/httpd/logs/ssl_error_log

[Sun Mar 02 17:16:05 2003] [warn] RSA server certificate is a CA certificate
(BasicConstraints: CA == TRUE !?)
[Sun Mar 02 17:16:05 2003] [warn] RSA server certificate CommonName (CN)
`localhost.localdomain' does NOT match server name!?
[Sun Mar 02 17:26:11 2003] [warn] RSA server certificate is a CA certificate
(BasicConstraints: CA == TRUE !?)
[Sun Mar 02 17:26:11 2003] [warn] RSA server certificate CommonName (CN)
`localhost.localdomain' does NOT match server name!?
[Sun Mar 02 17:32:28 2003] [warn] RSA server certificate is a CA certificate
(BasicConstraints: CA == TRUE !?)
[Sun Mar 02 17:32:28 2003] [warn] RSA server certificate CommonName (CN)
`localhost.localdomain' does NOT match server name!?

***************************************************
rpm -e mod_ssl "cures" the problem.

This happens on both PCs that I've tried 8.0.94 on.  Have tried it on a virgin
install, and get the same results.

Comment 1 Andrew Parker 2003-04-07 23:04:56 UTC
This problem does not ocurr on Red Hat 9 with either of the hardware that gave
me trouble before.  So far as I'm concerned, this problem can be closed.  Not
sure if I should instigate that or not.

Thanks

Comment 2 Joe Orton 2003-09-01 10:51:22 UTC
This was a genuine software bug in Phoebe (I can't find the bug number
off-hand), it was fixed for 9.

Comment 3 Ronen Siboni 2003-09-13 19:17:05 UTC
I'm running RH9 with the default Apache server that was installed on the 
system. All worked well for a long while but all of a sudden the same problem 
as described above occurs.

The submitter suggested "rpm -e mod_ssl" to cure the problem. The log messages 
from the ssl_error_log have disappeared but the problem persist:

[root@philip conf]# rpm -e mod_ssl
[root@philip conf]# httpd
[root@philip conf]# ps -ef | grep http
root     25304 18898  0 22:07 pts/2    00:00:00 grep http
[root@philip conf]# service httpd start
Starting httpd: [  OK  ]
[root@philip conf]# service httpd status
httpd dead but subsys locked



Note You need to log in before you can comment on or make changes to this bug.